Subject: [netconf] 答复: WGLC on draft-ietf-netconf-notification-messages? (Was Re: Configured receiver capability exchange)

From: Tianran Zhou <[email-masked]>
Date: Tue, 4 Feb 2020 03:26:54 +0000

Hi Eric,

I see “previous-message-id” is mentioned in the description of “message-generator-id” in section 3.
But there is no definition on “previous-message-id” in section 4.2
Did you drop this feature? Maybe you need to clean up the text on this.

Cheers,
Tianran

发件人: netconf [mailto:[email-masked]] 代表 Mahesh Jethanandani
发送时间: 2020年1月28日 8:19
收件人: Eric Voit (evoit) <[email-masked]>
抄送: [email-masked]
主题: [netconf] WGLC on draft-ietf-netconf-notification-messages? (Was Re: Configured receiver capability exchange)

Hi Eric,

This e-mail triggers two responses. Let us deal with draft-ietf-netconf-notification-messages here, and I will bring up comments/questions related to draft-ietf-netconf-https-notif in the other thread.

You have indicated a desire that receiver capabilities should be documented by the transport specific draft, e.g. draft-ietf-netconf-https-notif, and not this draft. As such you believe that the draft is ready.

To the WG, the authors have indicated a desire to wrap up this draft, and would like us, the chairs, to issue a WGLC on it. Before we do that, we wanted to ask if the WG believes that the document is ready, and that there are no more issues that need to discussed/addressed by draft-ietf-netconf-notification-messages document at this time.

Cheers.

Mahesh and Kent (as co-chairs).

On Jan 15, 2020, at 12:23 PM, Eric Voit (evoit) <[email-masked]<mailto:[email-masked]>> wrote:

Hi Mahesh,

During the IETF 106 session, there was discussion on how both a publisher might know if there is receiver support for draft-ietf-netconf-notification-messages<https://datatracker.ietf.org/doc/draft-ietf-netconf-notification-messages/?include_text=1>.  Section 6 highlights several of the considerations.   Relevant are the following:

(a) Remote device capability discovery from the point of view of the Publisher needs to be enhanced to know if the far end can interpret notification messages type beyond RFC-5277, Section 4.

(b) This capability discovery question is relevant for both configured subscription receivers and dynamic subscribers.

(c) The capability discovery question can be generalized beyond subscriptions, as there are many reasons to know the available capabilities of the far end.

(d) Capability discovery advertisement has traditionally been discussed within transport documents (e.g. RFC-6241 Section 8.1).

Based on (a)-(d), coming up with a transport independent point-solution within draft-ietf-netconf-notification-messages<https://datatracker.ietf.org/doc/draft-ietf-netconf-notification-messages/?include_text=1> *just* to discover this single element of client functionality seems overkill/heavyweight.

I was fine with letting this remote capabilities discovery question sit for a while.   However draft-ietf-netconf-https-notif<https://tools.ietf.org/html/draft-ietf-netconf-https-notif-01> shows that we now must address this question.  Specifically should the diagram section 1.4.1 show this capability exchange?

It turns out that independent of draft-ietf-netconf-notification-messages, there several questions in draft-ietf-netconf-https-notif which need to be answered prior to the section 1.4.1 arrow: "Send HTTPS POST message with YANG defined notification #1" anyway.  These questions are:
  (1) Does the targeted HTTPS receiver support configured subscriptions?
  (2) Can the targeted HTTP@ receiver accept a new subscription as described in a <subscription-started>?
Only if these questions are "yes", should the <subscription-started> be responded to with an "OK".

Add to this a third question driven from (a)-(d):
  (3) Does the receiver support the message type within "draft-ietf-netconf-notification-messages"?

A strawman way to handle the all three questions within draft-ietf-netconf-https-notif would be to respond to a <subscription-started> notification with an HTTP Status 202 (Accepted)" acknowledgement.  This 202 would include body elements listing supported receiver resources.  Maybe something YANG encoded via ietf-yang-structure-ext containing:

      <foo xmlns="urn:ietf:params:xml:ns:netconf:base:1.0">
        <capabilities>
          <capability>
            urn:ietf:params:xml:ns:yang:ietf-notification-messages:1.0
          </capability>
        </capabilities>
      </foo>

What do you think of this approach?

Eric

Mahesh Jethanandani
[email-masked]<mailto:[email-masked]>